SystemOrganization addCategory: #'CS528-WebSetback'!

WAFileLibrary subclass: #SetbackFiles
	instanceVariableNames: ''
	classVariableNames: 'Unmatched'
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

Object subclass: #SetbackWebSocketHandler
	instanceVariableNames: 'webSockets lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!SetbackWebSocketHandler class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/7/2013 23:27'!
name: clientName port: aPort
	^ self new
	name: clientName;
	port: aPort;
	yourself.! !

!SetbackWebSocketHandler class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/7/2013 19:28'!
on: aBlock
	^ self new
	block: aBlock;
	yourself.! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 20:47'!
distributeMessage: textMessage 
	"Send message to all client WebSockets that we know."
	lock critical: [
		webSockets do: [ :each |
			[ each sendMessage: textMessage]
				on: NetworkError 
				do: [ :exception |
					"We can ignore this (instead of #unregister:-ing the offender), 
					since the listener process (see #value:) will do the right thing" 
					each log debug: [ exception printString, ' in ditributeMessage, ignoring' ] ] ] ]
		"(FLSerializer serializeToByteArray:  (textMessage, ' ' , i asString))"! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:52'!
initialize
	webSockets := OrderedCollection new.
	lock := Mutex new.! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:52'!
register: clientWebSocket
	lock critical: [
		webSockets add: clientWebSocket ]! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:53'!
unregister: clientWebSocket
	lock critical: [
		webSockets remove: clientWebSocket ifAbsent: [ ] ]! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 14:00'!
value: webSocket
	[
	self register: webSocket.
	webSocket runWith: [ :message |	
		webSocket log info: [ 'Received message: ', message printString, ', echoing' ]. ] ] 
	on: ConnectionClosed 
	do: [ webSocket log debug: 'Ignoring connection close, done' ].
	
"textMessage := FLMaterializer materializeFromByteArray: (byteArrayMessage)."! !

Object subclass: #WebsocketUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 23:03'!
RegisterServer
ZnServer startDefaultOn: 1701.
ZnServer default logToTranscript.
ZnServer default delegate map: 'ws-setback' to:(ZnWebSocketDelegate map: 'ws-setback' to: SetbackWebSocketHandler new).! !

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 23:04'!
StopServer
	ZnServer stopDefault.! !

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 18:55'!
distributeMessage: aMessage
	(ZnServer default delegate prefixMap at: 'ws-setback')  handler distributeMessage: aMessage.! !

WAComponent subclass: #PlayerComponent
	instanceVariableNames: 'player playerId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!PlayerComponent class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:09'!
initialize 
	WAAdmin register: self asApplicationAt: 'player'.! !

!PlayerComponent class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:20'!
player: aPlayer 
	^self new player: aPlayer.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 23:45'!
cardImageName: aCard 
	^ aCard suit asString, aCard value asString capitalized, 'Png'.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:22'!
initialize 
	super initialize.
	player ifNil: [ player := (SetbackPlayer name: 'Terry')].! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:07'!
player
	^player.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:07'!
player: aPlayer 
	player := aPlayer.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 23:05'!
playerId: aPlayerComponentPlayerId
	playerId := aPlayerComponentPlayerId.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:25'!
renderBidOn: html 
	player currentBid ifNotNil:[
			html space.
			html text: 'bid:'.
			html text: player currentBid.
		].! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:25'!
renderContentOn: html 
	html text: player name .
	self renderBidOn: html.
	html table
		class: 'center';
		with: [
			html tableRow:
			[ 
				html tableHeading 
					class: 'playerCell';
					with: 'Score'.
				html tableHeading
					class: 'playerCell';
					with: 'Points Earned'.
				html tableHeading
					class: 'playerCell';
					with: 'Number of cards won' .].
				self renderPlayerDataOn: html.
		].
	self renderPlayerHandOn: html.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 20:44'!
renderPlayerDataOn: html
		html tableData 
			class: 'playerCell';
			with: (player gamesWon).
		html space.
		html tableData 
			class: 'playerCell';
			with: (player pointsEarned ).
		html space.
		html tableData 
			class: 'playerCell';
			with:  (player cardsWon size).
! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 23:41'!
renderPlayerHandOn: html
	(player playerId = playerId) ifFalse:[html image url: (SetbackFiles urlOf: #stackSixFaceDownPng)]
		ifTrue:[player hand cards do:[ :card |
				html anchor
				callback: [ self player playCard: card]; 
				with:[
			        html image
					url: (SetbackFiles urlOf: (self cardImageName: card));
					width: 60;
					height: 100.
					].
					].
				].! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 23:40'!
renderPlayerHandOnBackup: html
	(player playerId = playerId) ifFalse:[html image url: (SetbackFiles urlOf: #stackSixFaceDownPng)]
		ifTrue:[player hand cards do:[ :card |
			        html image
					url: (SetbackFiles urlOf: (self cardImageName: card));
					width: 60;
					height: 100.
					html anchor callback: [ self player playCard: card]; with: '++'.
					].
				].! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 20:38'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (SetbackFiles urlOf: #playerSetbackCss).! !

WAComponent subclass: #WebSetback
	instanceVariableNames: 'playerName setbakGame aPlayerComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

WebSetback class
	instanceVariableNames: 'playerComponents setbackGame currentHand'!

WebSetback class
	instanceVariableNames: 'playerComponents setbackGame currentHand'!

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:07'!
currentHand
	^currentHand.! !

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:09'!
currentHand: aHand
	currentHand := aHand.! !

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:42'!
initialize 
	super initialize.
	playerComponents := OrderedCollection new.
	setbackGame := SetbackGame setUpStandardGame.! !

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:24'!
playerComponents
	^playerComponents! !

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 23:52'!
register
	WAAdmin register: self asApplicationAt: 'WebSetback'.! !

!WebSetback class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 21:39'!
setbackGame
	^setbackGame.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:09'!
addPlayer
	|player|
	player := SetbackPlayer name: playerName.
	WebSetback setbackGame addPlayer: player.
	aPlayerComponent := PlayerComponent player: player.
	WebSetback playerComponents add: (aPlayerComponent).
	self refreshPage.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 20:58'!
bid2
	self playerBid:#two.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 20:58'!
bid3
	self playerBid:#three.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 20:59'!
bid4
	self playerBid:#four.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 21:16'!
cancel
    self answer: false.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:25'!
children 
	^WebSetback  playerComponents asArray.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 23:34'!
getCurrentPlayerClassAt: index
	|aComponent|
	WebSetback playerComponents size < index ifTrue:[^'otherPlayerCell'].
	(aPlayerComponent ifNil: [^'otherPlayerCell']).
	aComponent := (WebSetback playerComponents at: index).
"	aComponent = aPlayerComponent ifFalse:[^'otherPlayerCell']."

	^(aComponent player = WebSetback currentHand currentPhase nextPlayerToThrow) ifTrue:[^'currentPlayerCell'] ifFalse:[^'otherPlayerCell'].! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:24'!
initialize
	super initialize.	
	WebSetback playerComponents ifNil:[WebSetback  initialize.].
	WebSetback setbackGame ifNil:[WebSetback  initialize.].! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:53'!
isCurrentPlayer
	(aPlayerComponent ifNil: [^false]).
	^(aPlayerComponent  player = WebSetback currentHand currentPhase nextPlayerToThrow).! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:33'!
isCurrentPlayerAt: index
	|aComponent|
	WebSetback playerComponents size > index ifFalse:[^false].
	(aPlayerComponent ifNil: [^false]).
	aComponent := (WebSetback playerComponents at: index).
	aComponent = aPlayerComponent ifFalse:[^false].
	^(aPlayerComponent player = WebSetback currentHand currentPhase nextPlayerToThrow).! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/10/2013 15:52'!
message
	^message.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 20:58'!
pass
	self playerBid:#pass.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:39'!
playerBid: aValue
	aPlayerComponent player makeBid: aValue.
	(aPlayerComponent player = WebSetback currentHand dealer) ifTrue:[
		WebSetback currentHand startNextPhase.
		].
	self refreshPage.
	
! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:17'!
refreshPage
	"WebsocketUtilities distributeMessage: #refresh."! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:32'!
renderBidingButtonsOn: html
	|disable|
	WebSetback setbackGame started ifTrue: [ 
	disable := true.
	(aPlayerComponent player = WebSetback currentHand currentPhase currentBidder) ifTrue:[disable := false].
	   html space.
	   html submitButton disabled: disable; on: #pass of: self.
	   html space.
	   html submitButton disabled: disable; on: #bid2 of: self.
	   html space.
	   html submitButton disabled: disable; on: #bid3 of: self.
	   html space.
	   html submitButton disabled: disable; on: #bid4 of: self.
	 ].
	! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:58'!
renderContentOn: html
	html paragraph
		class: 'header'; 
		with: [
			html text: 'Welcome to CS528 - Setback project '; break.
			html text: 'Implemented by Ramesh, Terry, and Mehrdad'
		].
		html button
			callback: [ WebSetback initialize.];
			text: 'Reset the game'.
	
	html horizontalRule.
	
	html form:[
			self renderGameOn: html.
			self renderStartOn: html.
			self renderStartOverOn: html.
			self renderBidingButtonsOn:html.
		].
	
	
	html table: [ self renderMainTableOn: html. ].
	"
	html form:[
			html textInput
				id: 'txtMessage';
				callback: [ :value | textMessage := value].
			html button
				callback: [ self send ]; onClick: 'doSend(test)';
				text: 'Send'.
			html button
				callback: [ self connect ];
				text: 'Connect'.
			html button: 'Disconnect'.
		]."
	 html div id: #output.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 21:23'!
renderGameOn: html
	html render: 'Player name: '.
	html textInput
		id: 'txtMessage';
		callback: [ :value | playerName := value].
! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:36'!
renderMainTableOn: html 	
	|currentPlayerClass|
	html 
		tableRow: 
		[ 
			html tableData
				class: 'mainCell';
				with: 'empty'.
			html space.	
			html tableData
				class: 'mainCell';
				class: (self getCurrentPlayerClassAt: 1);
				with: [self renderPlayerCellOn: html at: 1].
			html space.
			html tableData
				class: 'mainCell';
				with:  'empty'.
		];
		tableRow: 
		[ 
			html tableData
				class: 'mainCell';
				class: (self getCurrentPlayerClassAt: 3);
				with: [self renderPlayerCellOn: html at: 3].
			html space.
			html tableData
				class: 'mainCell';				
				with: 'game table'.
			html space.
			html tableData	
				class: 'mainCell';
				class: (self getCurrentPlayerClassAt: 2);
				with: [self renderPlayerCellOn: html at: 2].
		].! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 22:08'!
renderPlayerCellOn: html at: index
	| playerComponent |
	WebSetback playerComponents size > (index - 1) ifTrue: [ 
	playerComponent := WebSetback playerComponents at: index. 
	WebSetback currentHand dealer = playerComponent player ifTrue:[html render: 'Dealer: '].
	aPlayerComponent ifNotNil: [playerComponent playerId: (aPlayerComponent player playerId)].
	html render: playerComponent.
	].! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 21:36'!
renderStartOn: html
	   html submitButton on: #addPlayer of: self.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 22:11'!
renderStartOverOn: html
	   html submitButton on: #startGame of: self.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/13/2013 16:56'!
send
	"webSocket sendMessage: (FLSerializer serializeToByteArray: textMessage)."! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/17/2013 21:34'!
startGame
	WebSetback playerComponents  size = 3 ifTrue: [ 
		WebSetback currentHand: WebSetback setbackGame startGame.
		WebSetback currentHand startNextPhase.
		WebSetback currentHand startNextPhase.
		self refreshPage.
	].! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/13/2013 16:55'!
updateOutput: html
"
	| rcvMessage |
		[[rcvMessage := FLMaterializer materializeFromByteArray: webSocket readMessage.
		Transcript show: rcvMessage; cr.
		html paragraph: [html text: rcvMessage.] repeat. ] fork."! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 20:39'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: (SetbackFiles urlOf: #webSocketJs).
	anHtmlRoot stylesheet url: (SetbackFiles urlOf: #setbackCss).
"	
	[ webSocket runWith: [ :msg |
			webSocket log info: [ 'Received message: ', msg printString ].]  ] 
		on: ConnectionClosed 
		do: [
			webSocket log debug: 'Connection close, cleaning up'.].
"		! !
WebSetback initialize!
PlayerComponent initialize!
